# Source code for azure.mgmt.resource.features.v2015_12_01.models._models_py3

    # coding=utf-8
    # --------------------------------------------------------------------------
    # Copyright (c) Microsoft Corporation. All rights reserved.
    # Licensed under the MIT License. See License.txt in the project root for
    # license information.
    #
    # Code generated by Microsoft (R) AutoRest Code Generator.
    # Changes may cause incorrect behavior and will be lost if the code is
    # regenerated.
    # --------------------------------------------------------------------------

    from msrest.serialization import Model

    class CloudError(Model):
        """CloudError.
        """

        _attribute_map = {
        }

    class FeatureProperties(Model):
        """Information about feature.

        :param state: The registration state of the feature for the subscription.
        :type state: str
        """

        _attribute_map = {
            'state': {'key': 'state', 'type': 'str'},
        }

        def __init__(self, *, state: str=None, **kwargs) -> None:
            super(FeatureProperties, self).__init__(**kwargs)
            self.state = state

    class FeatureResult(Model):
        """Previewed feature information.

        :param name: The name of the feature.
        :type name: str
        :param properties: Properties of the previewed feature.
        :type properties:
         ~azure.mgmt.resource.features.v2015_12_01.models.FeatureProperties
        :param id: The resource ID of the feature.
        :type id: str
        :param type: The resource type of the feature.
        :type type: str
        """

        _attribute_map = {
            'name': {'key': 'name', 'type': 'str'},
            'properties': {'key': 'properties', 'type': 'FeatureProperties'},
            'id': {'key': 'id', 'type': 'str'},
            'type': {'key': 'type', 'type': 'str'},
        }

        def __init__(self, *, name: str=None, properties=None, id: str=None, type: str=None, **kwargs) -> None:
            super(FeatureResult, self).__init__(**kwargs)
            self.name = name
            self.properties = properties
            self.id = id
            self.type = type

    class Operation(Model):
        """Microsoft.Features operation.

        :param name: Operation name: {provider}/{resource}/{operation}
        :type name: str
        :param display: The object that represents the operation.
        :type display:
         ~azure.mgmt.resource.features.v2015_12_01.models.OperationDisplay
        """

        _attribute_map = {
            'name': {'key': 'name', 'type': 'str'},
            'display': {'key': 'display', 'type': 'OperationDisplay'},
        }

        def __init__(self, *, name: str=None, display=None, **kwargs) -> None:
            super(Operation, self).__init__(**kwargs)
            self.name = name
            self.display = display

    class OperationDisplay(Model):
        """The object that represents the operation.

        :param provider: Service provider: Microsoft.Features
        :type provider: str
        :param resource: Resource on which the operation is performed: Profile,
         endpoint, etc.
        :type resource: str
        :param operation: Operation type: Read, write, delete, etc.
        :type operation: str
        """

        _attribute_map = {
            'provider': {'key': 'provider', 'type': 'str'},
            'resource': {'key': 'resource', 'type': 'str'},
            'operation': {'key': 'operation', 'type': 'str'},
        }

        def __init__(self, *, provider: str=None, resource: str=None, operation: str=None, **kwargs) -> None:
            super(OperationDisplay, self).__init__(**kwargs)
            self.provider = provider
            self.resource = resource
            self.operation = operation